<template>
    <div class="sw-gs-layout-wrapper" ref="templateRef">
        <div class="sw-gs-layout" :class="{ 'is-guide': isGuide }">
            <SwPluginSlot name="gs-presentation-layout-top"/>

            <SwNotifications/>

            <nuxt/>

            <SwPluginSlot name="gs-presentation-layout-bottom"/>
        </div>


        <template v-if="accessible">
            <SwPluginSlot name="gs-page-bottom"/>

            <SwPluginSlot name="gs-presentation-navigations">
                <SwGsNavigation/>
                <SwGsNavigationBottom/>
            </SwPluginSlot>
            <SwGsOffcanvas v-if="isSidebarOpen"/>
            <SwGsQuickViewModal :is-open="isQuickViewModalOpen" @close="switchQuickViewModalState(false)"/>

            <template v-if="isClient && !isSelfService">
                <SwGsAttendeeWelcomeModal/>
                <SwGsVideoSettingsModal v-if="callEnabled && !hasSavedSettings" />
                <SwGsLayerVideoClient v-if="callEnabled" />
            </template>

            <template v-if="isGuide">
                <SwPluginSlot class="sw-presentation-layer" name="gs-presentation-layer">
                    <SwGsLayer/>
                </SwPluginSlot>
                <SwGsVideoSettingsModal v-if="callEnabled" />
                <SwGsInstantListingModal v-if="isInstantListingModalOpen"></SwGsInstantListingModal>
                <SwGsEndAppointmentModal v-if="isEndAppointmentModalOpen"></SwGsEndAppointmentModal>
            </template>

        </template>

    </div>
</template>

<script>
  import { ref, watchEffect, computed, watch, provide, onMounted, onUnmounted } from "@vue/composition-api";
  import { useUIState, useUser } from "@shopware-pwa/composables";
  import { useAppointment } from "../logic/composables/useAppointment";
  import { useMediaDevices } from "../logic/composables/useMediaDevices";
  import { useState } from "../logic/composables/useState";
  import { useInstantListing } from "../logic/composables/useInstantListing";
  import { useMercureObserver } from "../logic/composables/useMercureObserver";
  import { useScrollToElement } from "../logic/composables/useScrollToElement";
  import { usePresentation } from "../logic/composables/usePresentation";
  import { useAdminApiInstance } from "../logic/composables/useAdminApiInstance";
  import { useVideoCall } from '../logic/composables/useVideoCall';
  import SwGsLayer from "../components/layer/SwGsLayer.vue"
  import SwGsNavigation from "../components/navigation/SwGsNavigation.vue"
  import SwGsNavigationBottom from "../components/navigation/SwGsNavigationBottom.vue"
  import SwGsLayerVideoClient from "../components/layer/SwGsLayerVideoClient.vue"
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
  import SwNotifications from "@/components/SwNotifications.vue";
  import SwGsInstantListingModal from '../components/instant-listing/SwGsInstantListingModal.vue';
  import SwGsQuickViewModal from "../components/modals/SwGsQuickViewModal";

  const SwGsEndAppointmentModal = () => import("../components/modals/SwGsEndAppointmentModal.vue");
  const SwGsOffcanvas = () => import("../components/offcanvas/SwGsOffcanvas.vue");
  const SwGsAttendeeWelcomeModal = () => import("../components/SwGsAttendeeWelcomeModal.vue");
  const SwGsVideoSettingsModal = () => import("../components/SwGsVideoSettingsModal.vue");

export default {
    components: {
        SwGsAttendeeWelcomeModal,
        SwGsVideoSettingsModal,
        SwGsLayer,
        SwGsLayerVideoClient,
        SwGsNavigation,
        SwGsNavigationBottom,
        SwGsOffcanvas,
        SwPluginSlot,
        SwNotifications,
        SwGsInstantListingModal,
        SwGsQuickViewModal,
        SwGsEndAppointmentModal
    },

    setup() {
      const { appointment, isGuide, isClient, isSelfService, joinedAppointment, attendeeName } = useAppointment();
      const {
        setDeviceToStorage, hasMediaDevicesStored, hasSavedSettings,
        init: initMediaDevices,
        cleanup: cleanupMediaDevices,
        cameraDevice,
        microphoneDevice,
        speakerDevice,
      } = useMediaDevices();
      const { stateForAll, showTokenPermissionsRequest, stateForMe } = useState();
      const { isOpen: isSidebarOpen } = useUIState({ stateName: "GS_OFFCANVAS_SIDEBAR_STATE" });
      const { isOpen: isAttendeeNameModalOpen, switchState: toggleAttendeeNameModal } = useUIState({ stateName: "GS_CLIENT_NAME_MODAL_STATE" });
      const { isOpen: isVideoModalOpen, switchState: toggleVideoModal } = useUIState({ stateName: "GS_VIDEO_MODAL_STATE" });
      const { isGuideAuthenticated } = useAdminApiInstance();
      const running = computed(() => stateForAll?.value?.running);
      const accessible = computed(() => {
        if (isGuide.value) return isGuideAuthenticated.value;
        if (!joinedAppointment.value) return false;
        if (isSelfService.value) return true;
        return running.value;
      });
      const { isOpen: isQuickViewModalOpen } = useUIState({ stateName: `GS_QUICKVIEW_MODAL_STATE` });
      const { isOpen: isEndAppointmentModalOpen } = useUIState({ stateName: `GS_END_APPOINTMENT_MODAL_STATE` });
      const { isLoggedIn } = useUser();
      const { scrollToTarget } = useMercureObserver();
      const { scrollToElement, setSlotContext } = useScrollToElement('');
      const {
        currentPageResponse
      } = usePresentation();
      const { callEnabled } = useVideoCall();

        // Load offcanvas component only when needed
        const loadSidebarComponent = ref(isSidebarOpen.value);
        const stopSidebarWatcher = watchEffect(() => {
            if (isSidebarOpen.value) {
                loadSidebarComponent.value = isSidebarOpen.value;
                stopSidebarWatcher()
            }
        });

        // Load client name modal component only when needed
        const loadModalComponent = ref(isAttendeeNameModalOpen.value);
        const stopModalWatcher = watchEffect(() => {
            if (isAttendeeNameModalOpen.value) {
                loadModalComponent.value = isAttendeeNameModalOpen.value;
                stopModalWatcher()
            }
        });

        // Load client name modal component only when needed
        const loadVideoModalComponent = ref(isVideoModalOpen.value);
        const stopVideoModalWatcher = watchEffect(() => {
            if (isVideoModalOpen.value) {
                loadVideoModalComponent.value = isVideoModalOpen.value;
                stopVideoModalWatcher()
            }
        });

        const {
            isInstantListingModalOpen
        } = useInstantListing();

        onMounted(() => {
            initMediaDevices();
        });

        onUnmounted(() => {
            cleanupMediaDevices();
        });

        provide("cms-page", currentPageResponse);

        // toggle modal if presentation is running and client joined but has no name
        watch(stateForAll, () => {
            let attendeeNameModalOpened = false;
            if (running.value && joinedAppointment.value) {
                if (
                    (stateForAll?.value.attendeeRestrictionType === 'open' && !attendeeName.value && !isLoggedIn.value) ||
                    (stateForAll?.value.attendeeRestrictionType === 'customer' && stateForMe.value && !stateForMe.value.attendeeSubmittedAt)
                ) {
                    toggleAttendeeNameModal(true);
                    attendeeNameModalOpened = true;
                }
            }

            if (!attendeeNameModalOpened && (attendeeName.value || isLoggedIn.value) && !hasMediaDevicesStored.value) {
                toggleVideoModal(true);
            }
        })

        // toggle modal if guide requested cart permissions
        watch(showTokenPermissionsRequest, () => {
            if (showTokenPermissionsRequest.value) {
                toggleAttendeeNameModal(true);
            }
        })

        watch(scrollToTarget, (target) => {
            if (!target || !target.elementId) return;
            if (appointment.value?.attendeeId === target.attendeeId) return;
            setSlotContext(target.slotContext);
            scrollToElement(target.elementId, target.index);
            scrollToTarget.value = null;
        });

        watch(microphoneDevice, (value) => setDeviceToStorage('microphone-device', value));
        watch(speakerDevice, (value) => setDeviceToStorage('speaker-device', value));
        watch(cameraDevice, (value) => setDeviceToStorage('camera-device', value));

        return {
            isGuide,
            isClient,
            isSelfService,
            isSidebarOpen: loadSidebarComponent,
            callEnabled,
            accessible,
            isQuickViewModalOpen,
            isInstantListingModalOpen,
            isEndAppointmentModalOpen,
            hasSavedSettings
        }
    },
    middleware: ["pages"],
}
</script>

<style lang="scss">
@import "../assets/scss/layouts/_presentation";

html,
body {
    position: fixed;
    overflow: hidden;
    height: 100%;
    width: 100%;
}

body {
    margin: 0;
}
</style>

<style lang="scss" scoped>
@import "@/assets/scss/variables";

.sw-gs-layout-wrapper {
    height: 100%;
    display: flex;
    flex-wrap: wrap;
}

.sw-presentation-layer {
    z-index:var(--presentation-layer-z-index);
}

.sw-gs-layout {
    flex-basis: 0;
    flex-grow: 1;
    max-width: 100%;
    height: 100%;
    overflow-y: auto;
    overflow-x: hidden;
    position: relative;

    ::v-deep .sw-gs-page-loader {
        position: static;
    }

    @include for-mobile {
        &.is-guide {
            margin-right: var(--presentation-layer-width-minimized);
        }
    }
}
</style>
